## arkostracker 3.2.7

=== CMakeLists.txt ===
project(MainSoftware VERSION ${PROJECT_VERSION})

set(APPLICATION_NAME "Arkos Tracker")

set(TargetName ${PROJECT_NAME})

# Generates the projectinfo.cpp from the template. Also see the target_include_directories at the bottom.
configure_file(ProjectInfo.h_cmake_template ProjectInfo.h)

# Specific icon according to the platform. "Windows" also possible.
if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")     # Mac.
    set(APP_ICON "../cpack/at3mac.png")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
    set(APP_ICON "../cpack/at3nsis.png")
else()
    set(APP_ICON "../cpack/at3.ico")
endif()

# https://github.com/juce-framework/JUCE/blob/master/docs/CMake%20API.md#juce_add_target
juce_add_gui_app(${TargetName}
        # VERSION ...                       # Set this if the app version is different to the project version
        # ICON_BIG ...                      # ICON_* arguments specify a path to an image file to use as an icon
        # ICON_SMALL ...
        # DOCUMENT_EXTENSIONS ...           # Specify file extensions that should be associated with this app
        PRODUCT_NAME "ArkosTracker3"        # The name of the final executable, which can differ from the target name
        BUNDLE_ID "com.julien-nevo.arkostracker"        # Mostly for macOS.
        ICON_BIG "${APP_ICON}"
        COMPANY_NAME "Julien Névo"          # Specify the name of the app's author
)

# Removing the need of signing for MacOsX. This probably doesn't really work.
# https://gitlab.kitware.com/cmake/cmake/-/issues/19879
set_target_properties(
        ${TargetName}
        PROPERTIES
        XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED NO
        XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY ""
        #XCODE_ATTRIBUTE_DEVELOPMENT_TEAM "${DEVELOPMENT_TEAM_ID}"
        #XCODE_ATTRIBUTE_PROVISIONING_PROFILE_SPECIFIER my_profile_name
        #XCODE_ATTRIBUTE_DEPLOYMENT_POSTPROCESSING YES   # this is needed for strip symbols
)

target_sources(${TargetName}
        PRIVATE
        Main.cpp
        ProjectInfo.h                       # Generated by CMake from a template (see configure_file above).

        commandLineTools/utils/CommandLineArgumentDescriptor.cpp
        commandLineTools/utils/CommandLineArgumentDescriptor.h
        commandLineTools/utils/CommandLineConstants.cpp
        commandLineTools/utils/CommandLineConstants.h
        commandLineTools/utils/CommandLineParser.cpp
        commandLineTools/utils/CommandLineParser.h
        commandLineTools/utils/Option.cpp
        commandLineTools/utils/Option.h
        commandLineTools/utils/Parameter.cpp
        commandLineTools/utils/Parameter.h
        commandLineTools/utils/CommandLineToolHelper.cpp
        commandLineTools/utils/CommandLineToolHelper.h

        app/preferences/FolderContext.h
        app/preferences/LastFolderTempStorage.cpp
        app/preferences/LastFolderTempStorage.h
        app/preferences/PreferencesManager.cpp
        app/preferences/PreferencesManager.h
        audio/effect/BaseEffect.cpp
        audio/effect/BaseEffect.h
        audio/effect/SpeakerEffect.cpp
        audio/effect/SpeakerEffect.h
        audio/effect/StereoSeparationEffect.cpp
        audio/effect/StereoSeparationEffect.h
        audio/effect/VolumeEffect.cpp
        audio/effect/VolumeEffect.h
        audio/sources/EffectsProcessor.cpp
        audio/sources/EffectsProcessor.h
        audio/sources/PsgsProcessor.cpp
        audio/sources/PsgsProcessor.h
        audio/sources/PsgStreamGenerator.cpp
        audio/sources/PsgStreamGenerator.h
        audio/sources/HardwareTables.cpp
        audio/sources/HardwareTables.h
        app/preferences/model/StoredOutputMix.cpp
        app/preferences/model/StoredOutputMix.h
        controllers/serial/model/SerialProfile.h
        audio/Volumes.cpp
        audio/Volumes.h
        business/CompoundAction.cpp
        business/CompoundAction.h
        business/actions/lists/AddItems.h
        business/actions/lists/DeleteItems.h
        business/actions/lists/MoveItems.h
        business/actions/instruments/psg/SetPsgInstrumentCell.cpp
        business/actions/instruments/psg/SetPsgInstrumentCell.h
        business/actions/instruments/psg/SetPsgInstrumentMetadata.cpp
        business/actions/instruments/psg/SetPsgInstrumentMetadata.h
        business/actions/instruments/psg/DuplicatePsgInstrumentCell.cpp
        business/actions/instruments/psg/DuplicatePsgInstrumentCell.h
        business/actions/instruments/psg/DeletePsgInstrumentCell.cpp
        business/actions/instruments/psg/DeletePsgInstrumentCell.h
        business/actions/instruments/psg/ModifyPsgInstrumentCells.cpp
        business/actions/instruments/psg/ModifyPsgInstrumentCells.h
        business/actions/instruments/psg/action/ToggleRetrigAction.cpp
        business/actions/instruments/psg/action/ToggleRetrigAction.h
        business/actions/instruments/psg/action/GenerateVolumeCellsAction.cpp
        business/actions/instruments/psg/action/GenerateVolumeCellsAction.h
        business/actions/instruments/sample/ModifySampleInstrumentMetadata.cpp
        business/actions/instruments/sample/ModifySampleInstrumentMetadata.h
        business/actions/instruments/sample/ChangeSample.cpp
        business/actions/instruments/sample/ChangeSample.h
        business/actions/instruments/AddInstruments.cpp
        business/actions/instruments/AddInstruments.h
        business/actions/instruments/DeleteInstruments.cpp
        business/actions/instruments/DeleteInstruments.h
        business/actions/instruments/InstrumentAction.cpp
        business/actions/instruments/InstrumentAction.h
        business/actions/instruments/MoveInstruments.cpp
        business/actions/instruments/MoveInstruments.h
        business/actions/instruments/RenameInstrument.cpp
        business/actions/instruments/RenameInstrument.h
        business/actions/instruments/SetInstrumentColor.cpp
        business/actions/instruments/SetInstrumentColor.h
        business/actions/instruments/SwapInstruments.cpp
        business/actions/instruments/SwapInstruments.h
        business/actions/instruments/RemapInstruments.cpp
        business/actions/instruments/RemapInstruments.h
        business/actions/expressions/AddExpressions.cpp
        business/actions/expressions/AddExpressions.h
        business/actions/expressions/DeleteExpressions.cpp
        business/actions/expressions/DeleteExpressions.h
        business/actions/expressions/ExpressionAction.cpp
        business/actions/expressions/ExpressionAction.h
        business/actions/expressions/MoveExpressions.cpp
        business/actions/expressions/MoveExpressions.h
        business/actions/expressions/ModifyExpressionCells.cpp
        business/actions/expressions/ModifyExpressionCells.h
        business/actions/expressions/SetExpressionCell.cpp
        business/actions/expressions/SetExpressionCell.h
        business/actions/expressions/SetExpressionCellMetadata.cpp
        business/actions/expressions/SetExpressionCellMetadata.h
        business/actions/expressions/RenameExpression.cpp
        business/actions/expressions/RenameExpression.h
        business/actions/expressions/DuplicateExpressionCell.cpp
        business/actions/expressions/DuplicateExpressionCell.h
        business/actions/expressions/DeleteExpressionCell.cpp
        business/actions/expressions/DeleteExpressionCell.h
        business/actions/linker/DeletePositions.cpp
        business/actions/linker/DeletePositions.h
        business/actions/linker/DuplicatePositions.cpp
        business/actions/linker/DuplicatePositions.h
        business/actions/linker/ClearPatterns.cpp
        business/actions/linker/ClearPatterns.h
        business/actions/linker/ClonePositions.cpp
        business/actions/linker/ClonePositions.h
        business/actions/linker/CreatePattern.cpp
        business/actions/linker/CreatePattern.h
        business/actions/linker/IncreasePatternInPosition.cpp
        business/actions/linker/IncreasePatternInPosition.h
        business/actions/linker/InsertPositions.cpp
        business/actions/linker/InsertPositions.h
        business/actions/linker/ModifyPosition.cpp
        business/actions/linker/ModifyPosition.h
        business/actions/linker/ModifyPositionMarker.cpp
        business/actions/linker/ModifyPositionMarker.h
        business/actions/linker/ModifyPositionsData.cpp
        business/actions/linker/ModifyPositionsData.h
        business/actions/linker/MovePositionMarker.cpp
        business/actions/linker/MovePositionMarker.h
        business/actions/linker/MovePositions.cpp
        business/actions/linker/MovePositions.h
        business/actions/linker/SetLoopStartAndEnd.cpp
        business/actions/linker/SetLoopStartAndEnd.h
        business/actions/linker/ModifyPattern.cpp
        business/actions/linker/ModifyPattern.h
        business/actions/linker/RearrangePatterns.cpp
        business/actions/linker/RearrangePatterns.h
        business/actions/patternViewer/SetCellData.cpp
        business/actions/patternViewer/SetCellData.h
        business/actions/patternViewer/SetPositionHeight.cpp
        business/actions/patternViewer/SetPositionHeight.h
        business/actions/patternViewer/SetSpecialCellData.cpp
        business/actions/patternViewer/SetSpecialCellData.h
        business/actions/patternViewer/SetTrackName.cpp
        business/actions/patternViewer/SetTrackName.h
        business/actions/patternViewer/SetSpecialTrackName.cpp
        business/actions/patternViewer/SetSpecialTrackName.h
        business/actions/patternViewer/PasteCells.cpp
        business/actions/patternViewer/PasteCells.h
        business/actions/patternViewer/LinkTrack.cpp
        business/actions/patternViewer/LinkTrack.h
        business/actions/patternViewer/LinkSpecialTrack.cpp
        business/actions/patternViewer/LinkSpecialTrack.h
        business/actions/patternViewer/CellsModifier.cpp
        business/actions/patternViewer/CellsModifier.h
        business/actions/patternViewer/DeleteNote.cpp
        business/actions/patternViewer/DeleteNote.h
        business/actions/patternViewer/ToggleReadOnly.cpp
        business/actions/patternViewer/ToggleReadOnly.h
        business/actions/patternViewer/Transpose.cpp
        business/actions/patternViewer/Transpose.h
        business/actions/patternViewer/TransposeNote.cpp
        business/actions/patternViewer/TransposeNote.h
        business/actions/patternViewer/TransposeRate.h
        business/actions/patternViewer/UnlinkSpecialTrack.cpp
        business/actions/patternViewer/UnlinkSpecialTrack.h
        business/actions/patternViewer/UnlinkTrack.cpp
        business/actions/patternViewer/UnlinkTrack.h
        business/actions/patternViewer/SwapCells.cpp
        business/actions/patternViewer/SwapCells.h
        business/actions/patternViewer/insertOrRemoveCellAt/InsertCellAt.cpp
        business/actions/patternViewer/insertOrRemoveCellAt/InsertCellAt.h
        business/actions/patternViewer/insertOrRemoveCellAt/RemoveCellAt.cpp
        business/actions/patternViewer/insertOrRemoveCellAt/RemoveCellAt.h
        business/actions/patternViewer/insertOrRemoveCellAt/InsertOrRemoveCellAt.cpp
        business/actions/patternViewer/insertOrRemoveCellAt/InsertOrRemoveCellAt.h
        business/actions/patternViewer/ClearCells.cpp
        business/actions/patternViewer/ClearCells.h
        business/actions/patternViewer/SelectedData.cpp
        business/actions/patternViewer/SelectedData.h
        business/actions/song/SetSongMetadata.cpp
        business/actions/song/SetSongMetadata.h
        business/actions/subsong/CreateSubsong.cpp
        business/actions/subsong/CreateSubsong.h
        business/actions/subsong/DeleteSubsong.cpp
        business/actions/subsong/DeleteSubsong.h
        business/actions/subsong/SetSubsongPsgs.h
        business/actions/subsong/SetSubsongPsgs.cpp
        business/actions/subsong/SetSubsongMetadata.cpp
        business/actions/subsong/SetSubsongMetadata.h
        business/actions/subsong/SubsongActionHelper.cpp

=== fap/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(ThirdPartyFap)

set(TargetName ${PROJECT_NAME})

add_library(${TargetName})

target_compile_definitions(${TargetName} PRIVATE)

target_sources(${TargetName}
        PRIVATE
        FapCrunch.h
        FapCrunch.cpp
        Lzss.cpp
        Lzss.h
        Types.h
        YmData.cpp
        YmData.h
        YmLoad.cpp
        YmLoad.h
)

=== lzh/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(ThirdPartyLzh)

set(TargetName ${PROJECT_NAME})

add_library(${TargetName})

target_compile_definitions(${TargetName} PRIVATE)

target_sources(${TargetName}
        PRIVATE
        LzhStSound.cpp
        LzhStSound.h
)

=== rasm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(ThirdPartyRasm)

set(TargetName ${PROJECT_NAME})

add_library(${TargetName})

target_compile_definitions(${TargetName} PRIVATE)

target_sources(${TargetName}
        PRIVATE
        minilib.h
        rasm.c
        rasm.h
)

=== serial/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(ThirdPartySerial)

set(TargetName ${PROJECT_NAME})

add_library(${TargetName})

target_compile_definitions(${TargetName} PRIVATE)

target_sources(${TargetName}
        PRIVATE
        src/impl/list_ports/list_ports_linux.cc
        src/impl/list_ports/list_ports_osx.cc
        src/impl/list_ports/list_ports_win.cc
        src/impl/unix.cc
        src/impl/win.cc
        src/serial.cc
        include/impl/unix.h
        include/impl/win.h
        include/serial.h
        include/v8stdint.h
)

=== commandLineTools/baseExport/CMakeLists.txt ===
# Empty project that declares the sources in the "SongToXXX..." project, so that there is no need
# to copy/paste them each time.

cmake_minimum_required(VERSION 3.12)

project(BaseExport)

set(TargetName ${PROJECT_NAME})

add_library(${TargetName})

target_compile_definitions(${TargetName} PRIVATE)

target_sources(
        ${TargetName}
        PRIVATE

        ../../audio/effect/BaseEffect.cpp
        ../../audio/effect/BaseEffect.h
        ../../audio/effect/SpeakerEffect.cpp
        ../../audio/effect/SpeakerEffect.h
        ../../audio/effect/StereoSeparationEffect.cpp
        ../../audio/effect/StereoSeparationEffect.h
        ../../audio/effect/VolumeEffect.cpp
        ../../audio/effect/VolumeEffect.h
        ../../audio/sources/EffectsProcessor.cpp
        ../../audio/sources/EffectsProcessor.h
        ../../audio/sources/PsgsProcessor.cpp
        ../../audio/sources/PsgsProcessor.h
        ../../audio/sources/PsgStreamGenerator.cpp
        ../../audio/sources/PsgStreamGenerator.h
        ../../audio/sources/HardwareTables.cpp
        ../../audio/sources/HardwareTables.h
        ../../app/preferences/model/StoredOutputMix.cpp
        ../../app/preferences/model/StoredOutputMix.h
        ../../controllers/serial/model/SerialProfile.h
        ../../audio/Volumes.cpp
        ../../audio/Volumes.h
        ../../business/model/Loop.cpp
        ../../business/model/Loop.h
        ../../business/model/StartEnd.cpp
        ../../business/model/StartEnd.h
        ../../business/model/Speed.h
        ../../business/patternViewer/DisplayedEffects.cpp
        ../../business/patternViewer/DisplayedEffects.h
        ../../business/serialization/patternViewer/EffectToCharSerializer.cpp
        ../../business/serialization/patternViewer/EffectToCharSerializer.h
        ../../business/serialization/patternViewer/TrackSerializer.cpp
        ../../business/serialization/patternViewer/TrackSerializer.h
        ../../business/serialization/song/ExpressionSerializer.cpp
        ../../business/serialization/song/ExpressionSerializer.h
        ../../business/serialization/instrument/InstrumentSerializer.cpp
        ../../business/serialization/instrument/InstrumentSerializer.h
        ../../business/serialization/instrument/InstrumentNodes.cpp
        ../../business/serialization/instrument/InstrumentNodes.h
        ../../business/serialization/song/PositionSerializer.cpp
        ../../business/serialization/song/PositionSerializer.h
        ../../business/serialization/song/PatternSerializer.cpp
        ../../business/serialization/song/PatternSerializer.h
        ../../business/serialization/song/CellSerializer.cpp
        ../../business/serialization/song/CellSerializer.h
        ../../business/serialization/song/SpecialCellSerializer.cpp
        ../../business/serialization/song/SpecialCellSerializer.h
        ../../business/serialization/sourceProfile/SourceProfileSerializer.cpp
        ../../business/serialization/sourceProfile/SourceProfileSerializer.h
        ../../business/serialization/sourceProfile/SourceProfileXmlNodes.cpp
        ../../business/serialization/sourceProfile/SourceProfileXmlNodes.h
        ../../business/sourceProfile/SourceProfile.cpp
        ../../business/sourceProfile/SourceProfile.h
        ../../business/sourceProfile/SourceProfileValidator.cpp
        ../../business/sourceProfile/SourceProfileValidator.h
        ../../business/song/cells/CellEffectsChecker.cpp
        ../../business/song/cells/CellEffectsChecker.h
        ../../business/song/tool/WaitCounter.cpp
        ../../business/song/tool/WaitCounter.h
        ../../business/song/tool/InstrumentSimpleCounter.cpp
        ../../business/song/tool/InstrumentSimpleCounter.h
        ../../business/song/tool/browser/CellAndLocation.cpp
        ../../business/song/tool/browser/CellAndLocation.h
        ../../business/song/tool/browser/CellBrowser.cpp
        ../../business/song/tool/browser/CellBrowser.h
        ../../business/song/tool/browser/SpecialCellBrowser.cpp
        ../../business/song/tool/browser/SpecialCellBrowser.h
        ../../business/song/tool/browser/SpecialCellAndLocation.cpp
        ../../business/song/tool/browser/SpecialCellAndLocation.h
        ../../business/song/tool/browser/TrackBrowser.cpp
        ../../business/song/tool/browser/TrackBrowser.h
        ../../business/song/tool/ChangeExpressionsOrdering.cpp
        ../../business/song/tool/ChangeExpressionsOrdering.h
        ../../business/song/tool/ChangeInstrumentsOrdering.cpp
        ../../business/song/tool/ChangeInstrumentsOrdering.h
        ../../business/song/tool/builder/SongBuilder.cpp
        ../../business/song/tool/builder/SongBuilder.h
        ../../business/song/tool/builder/SubsongBuilder.cpp
        ../../business/song/tool/builder/SubsongBuilder.h
        ../../business/song/tool/builder/PatternUnoptimizer.cpp
        ../../business/song/tool/builder/PatternUnoptimizer.h
        ../../business/song/tool/builder/TrailingEffectContext.cpp
        ../../business/song/tool/builder/TrailingEffectContext.h
        ../../business/song/tool/frameCounter/FrameCounter.cpp
        ../../business/song/tool/frameCounter/FrameCounter.h
        ../../business/song/tool/speed/DetermineSpeed.cpp
        ../../business/song/tool/speed/DetermineSpeed.h
        ../../business/song/tool/songStripper/SongStripper.cpp
        ../../business/song/tool/songStripper/SongStripper.h
        ../../business/song/tool/songStripper/SubsongsAndPsgs.cpp
        ../../business/song/tool/songStripper/SubsongsAndPsgs.h
        ../../business/song/tool/BaseNoteFinder.cpp
        ../../business/song/tool/BaseNoteFinder.h
        ../../business/song/tool/CellOperations.cpp
        ../../business/song/tool/CellOperations.h
        ../../business/song/tool/ChangeExpressionsOrdering.cpp
        ../../business/song/tool/ChangeExpressionsOrdering.h
        ../../business/song/tool/ChangeInstrumentsOrdering.cpp
        ../../business/song/tool/ChangeInstrumentsOrdering.h
        ../../business/song/tool/InlineArpeggioConverter.cpp
        ../../business/song/tool/InlineArpeggioConverter.h
        ../../business/song/tool/RetrigInInstrumentHeaderNormalizer.cpp
        ../../business/song/tool/RetrigInInstrumentHeaderNormalizer.h
        ../../business/song/tool/optimizers/BaseItemOptimizer.h
        ../../business/song/tool/optimizers/ExpressionOptimizer.cpp
        ../../business/song/tool/optimizers/ExpressionOptimizer.h
        ../../business/song/tool/optimizers/ExpressionsOptimizer.cpp
        ../../business/song/tool/optimizers/ExpressionsOptimizer.h
        ../../business/song/tool/optimizers/InstrumentOptimizer.cpp
        ../../business/song/tool/optimizers/InstrumentOptimizer.h
        ../../business/song/tool/optimizers/InstrumentsOptimizer.cpp
        ../../business/song/tool/optimizers/InstrumentsOptimizer.h
        ../../business/song/tool/optimizers/PatternOptimizer.cpp
        ../../business/song/tool/optimizers/PatternOptimizer.h
        ../../business/song/tool/optimizers/SongOptimizer.cpp
        ../../business/song/tool/optimizers/SongOptimizer.h
        ../../business/song/tool/sfx/FirstNotePerInstrumentFinder.cpp
        ../../business/song/tool/sfx/FirstNotePerInstrumentFinder.h
        ../../business/song/tool/context/model/LineContext.cpp
        ../../business/song/tool/context/model/LineContext.h
        ../../business/instrument/GenericInstrumentGenerator.cpp
        ../../business/instrument/GenericInstrumentGenerator.h
        ../../business/song/validation/CheckLoopStartEnd.cpp
        ../../business/song/validation/CheckLoopStartEnd.h
        ../../business/song/validation/CheckTrackHeight.cpp
        ../../business/song/validation/CheckTrackHeight.h
        ../../business/song/validation/CorrectExpression.cpp
        ../../business/song/validation/CorrectExpression.h
        ../../business/song/validation/CorrectInstrument.cpp
        ../../business/song/validation/CorrectInstrument.h
        ../../business/song/validation/LoopChange.cpp
        ../../controllers/model/OutputMix.cpp
        ../../controllers/model/OutputMix.h
        ../../controllers/model/Follow.h
        ../../export/at3/SongNodes.cpp
        ../../export/at3/SongNodes.h
        ../../export/samples/SampleEncoderFlags.cpp
        ../../export/samples/SampleEncoderFlags.h
        ../../export/ExportConfiguration.cpp
        ../../export/ExportConfiguration.h
        ../../import/soundtrakker/Stk128Importer.cpp
        ../../import/soundtrakker/Stk128Importer.h
        ../../import/soundtrakker/SubsongImporter.cpp
        ../../import/soundtrakker/SubsongImporter.h
        ../../import/soundtrakker/Stk128Constants.h
        ../../import/starkos/StarkosImporter.cpp
        ../../import/starkos/StarkosImporter.h
        ../../import/starkos/InstrumentReader.cpp
        ../../import/starkos/InstrumentReader.h
        ../../import/starkos/TrackReader.cpp
        ../../import/starkos/TrackReader.h
        ../../import/at1/At1SongImporter.cpp
        ../../import/at1/At1SongImporter.h
        ../../import/at2/At2SongImporter.cpp
        ../../import/at2/At2SongImporter.h
        ../../import/at2/SubsongReader.cpp
        ../../import/at2/SubsongReader.h
        ../../import/at3/At3SongImporter.cpp
        ../../import/at3/At3SongImporter.h
        ../../import/chp/ChpSongImporter.cpp
        ../../import/chp/ChpSongImporter.h
        ../../import/vt2/Vt2SongImporter.cpp
        ../../import/vt2/Vt2SongImporter.h
        ../../import/vt2/Vt2InstrumentBuilder.cpp
        ../../import/vt2/Vt2InstrumentBuilder.h
        ../../import/wyz/WyzSongImporter.cpp
        ../../import/wyz/WyzSongImporter.h
        ../../import/SongImporter.h
        ../../import/ImportedFormat.h
        ../../import/loader/SongLoader.cpp
        ../../import/loader/SongLoader.h
        ../../import/loader/configuration/ImportConfiguration.cpp
        ../../import/loader/configuration/ImportConfiguration.h
        ../../import/loader/configuration/ImportFirstPassReturnData.h
        ../../import/mod/ModConfiguration.cpp
        ../../import/mod/ModConfiguration.h
        ../../import/mod/ModTrackCell.cpp
        ../../import/mod/ModTrackCell.h
        ../../import/mod/ModSongImporter.cpp
        ../../import/mod/ModSongImporter.h
        ../../import/midi/MidiConfiguration.cpp
        ../../import/midi/MidiConfiguration.h
        ../../import/midi/MidiImporter.cpp
        ../../import/midi/MidiImporter.h
        ../../import/midi/MidiTrackReader.cpp
        ../../import/midi/MidiTrackReader.h
        ../../import/common/ChannelMixerKeeper.cpp
        ../../import/common/ChannelMixerKeeper.h
        ../../import/ConfigurationType.h
        ../../reader/StreamedMusicReader.cpp
        ../../reader/StreamedMusicReader.h
        ../../reader/ym/YmReader.cpp
        ../../reader/ym/YmReader.h
        ../../reader/ym/decoder/YmDecoder.cpp
        ../../reader/ym/decoder/YmDecoder.h
        ../../reader/ym/decoder/YmDecoder123.cpp
        ../../reader/ym/decoder/YmDecoder123.h
        ../../reader/ym/decoder/YmDecoder3b.cpp
        ../../reader/ym/decoder/YmDecoder3b.h
        ../../reader/ym/decoder/YmDecoder456.cpp
        ../../reader/ym/decoder/YmDecoder456.h
        ../../reader/vgm/VgmReader.cpp
        ../../reader/vgm/VgmReader.h
        ../../disark/base/AreaTag.cpp
        ../../disark/base/AreaTag.h
        ../../utils/ErrorReport.cpp
        ../../utils/ErrorReport.h
        ../../utils/StreamUtil.cpp
        ../../utils/StreamUtil.h
        ../../utils/SpeedUtil.cpp
        ../../utils/SpeedUtil.h
        ../../utils/Base64Util.cpp
        ../../utils/Base64Util.h
        ../../player/channel/ChannelOutputRegisters.cpp
        ../../player/channel/ChannelOutputRegisters.h
        ../../player/channel/ChannelPlayer.cpp
        ../../player/channel/ChannelPlayer.h
        ../../player/channel/ChannelPlayerResults.cpp
        ../../player/channel/ChannelPlayerResults.h

=== commandLineTools/songToAkg/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(SongToAkg VERSION 1.0.0)

set(TargetName ${PROJECT_NAME})

juce_add_console_app(${TargetName}
        PRODUCT_NAME "Song to AKG")

target_sources(${TargetName}
        PRIVATE
        main.cpp
        Tool.cpp
        Tool.h

        ../../../source/export/akg/AkgExporter.cpp
        ../../../source/export/akg/AkgExporter.h
        ../../../source/export/akg/process/AkgPattern.cpp
        ../../../source/export/akg/process/AkgPattern.h
        ../../../source/export/akg/process/AkgPatternItem.cpp
        ../../../source/export/akg/process/AkgPatternItem.h
        ../../../source/export/akg/process/AkgSubsongExporter.cpp
        ../../../source/export/akg/process/AkgSubsongExporter.h
        ../../../source/export/akg/process/EncodedEffect.h
        ../../../source/export/akg/process/EncodedEffectBlock.cpp
        ../../../source/export/akg/process/EncodedEffectBlock.h
        ../../../source/export/akg/process/LinkerBlock.cpp
        ../../../source/export/akg/process/LinkerBlock.h
        ../../../source/export/akg/process/LinkerBlockContainer.cpp
        ../../../source/export/akg/process/LinkerBlockContainer.h
        ../../../source/export/akg/process/PsgInstrumentCellEncoder.cpp
        ../../../source/export/akg/process/PsgInstrumentCellEncoder.h
        ../../../source/export/samples/SampleCodeGenerator.cpp
        ../../../source/export/samples/SampleCodeGenerator.h
        ../../../source/export/samples/SampleEncoder.cpp
        ../../../source/export/samples/SampleEncoder.h
        ../../../source/export/samples/SampleEncoderFlags.cpp
        ../../../source/export/samples/SampleEncoderFlags.h
        ../../../source/export/SongExportResult.cpp
        ../../../source/export/SongExportResult.h

        ../../../source/business/instrument/SampleResampler.cpp
        ../../../source/business/instrument/SampleResampler.h
)

target_link_libraries(${TargetName}
        PRIVATE
        BaseExport
        juce::juce_core
        PUBLIC
        juce::juce_recommended_config_flags
        juce::juce_recommended_lto_flags
        juce::juce_recommended_warning_flags
)

=== commandLineTools/songToAkm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(SongToAkm VERSION 1.0.0)

set(TargetName ${PROJECT_NAME})

juce_add_console_app(${TargetName}
        PRODUCT_NAME "Song to AKM")

target_sources(${TargetName}
        PRIVATE
        main.cpp
        Tool.cpp
        Tool.h

        ../../../source/export/akm/AkmExporter.cpp
        ../../../source/export/akm/AkmExporter.h
        ../../../source/export/akm/process/AkmInstrumentEncoder.cpp
        ../../../source/export/akm/process/AkmInstrumentEncoder.h
        ../../../source/export/akm/process/AkmSequenceEncoder.cpp
        ../../../source/export/akm/process/AkmSequenceEncoder.h
        ../../../source/export/akm/process/AkmSongEncoder.cpp
        ../../../source/export/akm/process/AkmSongEncoder.h
        ../../../source/export/akm/process/AkmSubsongEncoder.cpp
        ../../../source/export/akm/process/AkmSubsongEncoder.h
        ../../../source/export/akm/process/LinkerEncoder.cpp
        ../../../source/export/akm/process/LinkerEncoder.h
        ../../../source/export/SongExportResult.cpp
        ../../../source/export/SongExportResult.h
)

target_compile_features(${TargetName} PRIVATE cxx_std_11)

target_link_libraries(${TargetName}
        PRIVATE
        BaseExport
        juce::juce_core
        PUBLIC
        juce::juce_recommended_config_flags
        juce::juce_recommended_lto_flags
        juce::juce_recommended_warning_flags
)

=== commandLineTools/songToAky/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(SongToAky VERSION 1.0.0)

set(TargetName ${PROJECT_NAME})

juce_add_console_app(${TargetName}
        PRODUCT_NAME "Song to AKY")

target_sources(${TargetName}
        PRIVATE
        main.cpp
        Tool.cpp
        Tool.h

        ../../../source/export/aky/AkyExporter.cpp
        ../../../source/export/aky/AkyExporter.h
        ../../../source/export/aky/process/RegisterBlockLabelProvider.h
        ../../../source/export/aky/process/AkyConstants.h
        ../../../source/export/aky/process/AkyPattern.cpp
        ../../../source/export/aky/process/AkyPattern.h
        ../../../source/export/aky/process/AkyPatterns.cpp
        ../../../source/export/aky/process/AkyPatterns.h
        ../../../source/export/aky/process/AkyTrack.cpp
        ../../../source/export/aky/process/AkyTrack.h
        ../../../source/export/aky/process/ChannelData.cpp
        ../../../source/export/aky/process/ChannelData.h
        ../../../source/export/aky/process/EncodedLine.cpp
        ../../../source/export/aky/process/EncodedLine.h
        ../../../source/export/aky/process/EncodedLine.cpp
        ../../../source/export/aky/process/EncodedLine.h
        ../../../source/export/aky/process/EncodedSequence.cpp
        ../../../source/export/aky/process/EncodedSequence.h
        ../../../source/export/aky/process/RegisterBlock.cpp
        ../../../source/export/aky/process/RegisterBlock.h
        ../../../source/export/aky/process/RegisterBlockEncoder.cpp
        ../../../source/export/aky/process/RegisterBlockEncoder.h
        ../../../source/export/aky/process/RegisterBlockLabelProvider.h
        ../../../source/export/aky/process/RegisterBlockOptimizer.cpp
        ../../../source/export/aky/process/RegisterBlockOptimizer.h
        ../../../source/export/aky/process/RegisterBlockPool.cpp
        ../../../source/export/aky/process/RegisterBlockPool.h
        ../../../source/export/SongExportResult.cpp
        ../../../source/export/SongExportResult.h
)

target_link_libraries(${TargetName}
        PRIVATE
        BaseExport
        juce::juce_core
        PUBLIC
        juce::juce_recommended_config_flags
        juce::juce_recommended_lto_flags
        juce::juce_recommended_warning_flags
)

=== commandLineTools/songToEvents/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(SongToEvents VERSION 1.0.0)

set(TargetName ${PROJECT_NAME})

juce_add_console_app(${TargetName}
        PRODUCT_NAME "Song to events")

target_sources(${TargetName}
        PRIVATE
        main.cpp
        Tool.cpp
        Tool.h

        ../../../source/export/events/EventsExporter.cpp
        ../../../source/export/events/EventsExporter.h
        ../../../source/export/SongExportResult.cpp
        ../../../source/export/SongExportResult.h
)

target_link_libraries(${TargetName}
        PRIVATE
        BaseExport
        juce::juce_core
        PUBLIC
        juce::juce_recommended_config_flags
        juce::juce_recommended_lto_flags
        juce::juce_recommended_warning_flags
)

=== commandLineTools/songToFap/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(SongToFap VERSION 1.0.0)

set(TargetName ${PROJECT_NAME})

# Generates the projectinfo.cpp from the template. Also see the target_include_directories at the bottom.
configure_file(../../ProjectInfo.h_cmake_template ProjectInfo.h)

juce_add_console_app(${TargetName}
        PRODUCT_NAME "Song to FAP")

target_sources(${TargetName}
        PRIVATE
        main.cpp
        Tool.cpp
        Tool.h
        ProjectInfo.h                       # Generated by CMake from a template (see configure_file above).

        ../../../source/export/fap/FapExporter.cpp
        ../../../source/export/fap/FapExporter.h
        ../../../thirdParty/fap/FapCrunch.cpp
        ../../../thirdParty/fap/FapCrunch.h
        ../../../thirdParty/fap/Lzss.cpp
        ../../../thirdParty/fap/Lzss.h
        ../../../thirdParty/fap/Types.h
        ../../../thirdParty/fap/YmData.cpp
        ../../../thirdParty/fap/YmData.h
        ../../../thirdParty/fap/YmLoad.cpp
        ../../../thirdParty/fap/YmLoad.h

        ../../../source/export/ym/YmExporter.cpp
        ../../../source/export/ym/YmExporter.h
        ../../../source/export/ym/YmStreamEncoder.cpp
        ../../../source/export/ym/YmStreamEncoder.h
        ../../../source/export/ym/YmStreamEncoderInterleaved.cpp
        ../../../source/export/ym/YmStreamEncoderInterleaved.h
        ../../../source/export/ym/YmStreamEncoderNonInterleaved.cpp
        ../../../source/export/ym/YmStreamEncoderNonInterleaved.h

        ../../../source/export/samples/SampleEncoder.cpp
        ../../../source/export/samples/SampleEncoder.h
        ../../../source/export/samples/SampleCodeGenerator.cpp
        ../../../source/export/samples/SampleCodeGenerator.h
        ../../../source/export/samples/SampleEncoderFlags.cpp
        ../../../source/export/samples/SampleEncoderFlags.h

        ../../../source/business/instrument/SampleResampler.cpp
        ../../../source/business/instrument/SampleResampler.h
)

# This allows the generated file by CMake (such as projectinfo.h) to be seen by the sources.
target_include_directories(${TargetName}
        PRIVATE
        ${PROJECT_BINARY_BIN}
)

target_link_libraries(${TargetName}
        PRIVATE
        BaseExport
        ThirdPartyFap
        juce::juce_core
        PUBLIC
        juce::juce_recommended_config_flags
        juce::juce_recommended_lto_flags
        juce::juce_recommended_warning_flags
)

=== commandLineTools/songToRaw/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(SongToRaw VERSION 1.0.0)

set(TargetName ${PROJECT_NAME})

juce_add_console_app(${TargetName}
        PRODUCT_NAME "Song to RAW")

target_sources(${TargetName}
        PRIVATE
        main.cpp
        Tool.cpp
        Tool.h

        ../../../source/export/SongExportResult.cpp
        ../../../source/export/SongExportResult.h
        ../../../source/export/model/EncodedDataFlag.cpp
        ../../../source/export/model/EncodedDataFlag.h
        ../../../source/export/raw/RawExporter.cpp
        ../../../source/export/raw/RawExporter.h
        ../../../source/export/samples/SampleCodeGenerator.cpp
        ../../../source/export/samples/SampleCodeGenerator.h
        ../../../source/export/samples/SampleEncoder.cpp
        ../../../source/export/samples/SampleEncoder.h
        ../../../source/export/samples/SampleEncoderFlags.cpp
        ../../../source/export/samples/SampleEncoderFlags.h

        ../../../source/business/instrument/SampleResampler.cpp
        ../../../source/business/instrument/SampleResampler.h
)

target_link_libraries(${TargetName}
        PRIVATE
        BaseExport
        juce::juce_core
        PUBLIC
        juce::juce_recommended_config_flags
        juce::juce_recommended_lto_flags
        juce::juce_recommended_warning_flags
)

=== debian/changelog ===
arkostracker (3.2.7-0ddebs1~ubuntu22.04) jammy; urgency=medium

  * New upstream release.
  * adapt to cross-compilation

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 23 Nov 2025 00:09:36 +0100

arkostracker (3.2.2-0ddebs1) unstable; urgency=medium

  * Initial release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 26 Jan 2025 03:44:25 +0100

=== debian/control ===
Source: arkostracker
Section: utils
Priority: optional
Maintainer: Nicolas HOUDELOT <nicolas@demosdebs.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 mesa-common-dev,
 libasound2-dev,
 libfreetype-dev,
 libcurl4-openssl-dev,
 libxrandr-dev,
 libxinerama-dev,
 libxext-dev,
 libxcursor-dev,
 libxcomposite-dev
Standards-Version: 4.6.2
Homepage: https://julien-nevo.com/at3test/

Package: arkostracker
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 arkostracker-data
Description: Music software specialised on retro-computers
 Music software specialised on retro-computers such Amstrad CPC, ZX Spectrum, 
 Atari ST and so on, which all share the same soundchip, the AY-3-8912 and 
 YM-2149F

Package: arkostracker-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Data files for arkostracker
 arkostracker data files

=== debian/watch ===
version=4
opts="mode=git,pgpmode=auto,repack,compression=xz,filenamemangle=s/.+\/v?(\d[\d.]*)\.tar\.gz/arkostracker3-$1.tar.gz/" \
	https://bitbucket.org/JulienNevo/arkostracker3.git refs/tags/(\d+).(\d+).(\d+) \
debian uupdate
